/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Calculates amount of drive space free                                  *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 *  Thanks to Peter Fitzsimmons for these routines.                        *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <dos.h>


#ifdef OS_2
#define INCL_NOPM
#include <os2.h>
#include "prog.h"

long zfree(char *path)
{
    int drive;
    FSALLOCATE dt;

    if(!path || !*path)
        drive = 0;
    else
        drive = tolower(*path) - 'a' + 1;
    DosQFSInfo(drive,1, (char far *) &dt, sizeof(FSALLOCATE));
    return( dt.cSectorUnit *
            dt.cUnitAvail *
            dt.cbSector );
}
#else
long zfree (char *drive)
{
  union REGS r;
  unsigned char driveno;

  if (drive[0] != '\0' && drive[1] == ':')
    driveno=toupper(*drive)-'A'+1;
  else driveno=0;                             /* Default drive */

  r.x.ax=0x3600;                              /* get free space */
  r.h.dl=driveno;                             /* on this drive */
  intdos(&r,&r);                              /* go do it */

  if (r.x.ax==0xffff)                         /* error return? */
    return 0L;

  return((long)r.x.bx*(long)r.x.ax*(long)r.x.cx);
}
#endif

